@(echo off 2>nul 3>nul
start/B mode concols=80lines=22
title Extraction and Normalization Tool (Ampere^)
pushd "%~dp0"
if exist temp2 rd/S/Q temp2
if not exist "%~1" call:The_End "No file input detected, please drag and drop the firmware file to the batch")
if %~z1 gtr 512000 if %~z1 lss 2097153 goto Size_Pass
call:The_End "Please check the file size and try again"
:Size_Pass
md temp2&&start/B %SystemRoot%\System32\attrib.exe +h +s temp2
(%SystemRoot%\System32\certutil.exe -encodehex "%~1" temp2\FW 4 >nul||call:The_End "Firmware read error, please check and try again"
setlocal enabledelayedexpansion
for /F "tokens=1,2 delims=:" %%i in ('start/B %SystemRoot%\System32\findstr.exe /NRC:"^55 aa .. 00 f1 0e" /C:"^[0d][0e] [01]0 .. .. 00 00 1c 00" /C:"^4e 50 44 45 00 01 10 00" temp2\FW')do (
	set raw=%%j
	set/A"rcheck=(%%i)%%32"
	if !rcheck!==1 (
		set/Anext_line=%%i+2
		set raw[1]=%%j
	)
	if %%i==!next_line! (
		set/Anext_line2=!next_line!+2
		set raw[2]=%%j
	)
	if %%i==!next_line2! (
		if "0x!raw:~37,2!" gtr "0x!iVer!" (
			if "0x!raw:~44,1!" lss "0x6" call:The_End "Unsupported architecture(0x!raw:~44,1!00!raw:~37,2!)"
			set iMCA=!raw:~44,1!
			set iHeader=%%i
			set iBlock=!raw[1]:~6,2!
			for /F "tokens=1-4" %%k in ("!raw[2]!")do if not "%%l%%k"=="0000" set iDID=%%n%%m
			set iVer=!raw:~37,2!
		)
	)
)
if not defined iVer call:The_End "No GOP module detected")
for %%# in (%iMCA%*.efi)do (
	if /I "%%~x#"==".efi" (
		set "cand=%%~n#"
		if "%iBlock%"=="!cand:~3,2!" (
			if "0x%iVer%" lss "0x!cand:~1,2!" (call:The_End "A newer version of the GOP module file already exists")else if "%iVer%%iDID%"=="!cand:~1,2!!cand:~5,4!" call:The_End "An identical GOP module file already exists"
		)
	)
)
%SystemRoot%\System32\certutil.exe -encodehex "%~1" temp2\FW2 12 >nul
for /F %%# in ('start/B powershell "$c=gc temp2\FW2;foreach($k in '020255000000000000','000000000008000006100100'){$c.IndexOf($k,64000)}"')do set/Am+=1&set SIG[!m!]=%%#
if not defined SIG[2] call:The_End "Digital signature not found"
set/ASIG_S[2]=SIG[2]-32,GOP_S=(iHeader-5)*32,GOP_Size=0x%iBlock%*1024,oSize=GOP_Size/2+468
for %%# in (%iMCA%%iVer%%iBlock%*.efi)do if "%%~z#" gtr "548" set/AGOP_Size=160,oSize=548
powershell "$s=@(@{Start=%SIG[1]%;Length=104},@{Start=%SIG_S[2]%;Length=832},@{Start=%GOP_S%;Length=%GOP_Size%});$fsi=[IO.File]::OpenRead('temp2\FW2');$fso=[IO.File]::Create('temp2\GOP');foreach($s in $s){$buffer=[byte[]]::new($s.Length);$fsi.Seek($s.Start,0)|Out-Null;$count=$fsi.Read($buffer,0,$s.Length);$fso.Write($buffer,0,$count)};$fsi.Close();$fso.Close();"
%SystemRoot%\System32\certutil.exe -decodehex temp2\GOP %iMCA%%iVer%%iBlock%%iDID%.efi>nul
for %%# in (%iMCA%%iVer%%iBlock%%iDID%.efi)do if "%%~z#"=="%oSize%" (call:The_End "[92mGOP module for 0x%iMCA%00%iVer% has been extracted")else del %%#&call:The_End "Extraction failed due to unknown error"
:The_End
rd/S/Q temp2
for /F "delims=#" %%i in ('"prompt $E#&for %%# in (#)do rem"')do for /L %%# in (6,-1,1)do cls&echo;&echo [93m%~1.[0m&echo;&echo Automatically close after %%# second...&echo;&echo;&echo;&echo Version 0.2.3 (20241207)&echo Copyright (C) 2021-2024 Wudimobile%%i[?25l&timeout/T 1 >nul
exit