@(echo off 2>nul 3>nul
start/B mode concols=80lines=22
title GOP Update Tool (Ampere^)
pushd "%~dp0"
if exist temp rd/S/Q temp
if not exist "%~1" call:The_End "No file input detected, please drag and drop the firmware file to the batch")
if %~z1 gtr 512000 if %~z1 lss 2097153 goto Size_Pass
call:The_End "Please check the file size and try again"
:Size_Pass
if not exist *.efi call:The_End "Missing available GOP module files, please confirm and try again"
md temp&&start/B %SystemRoot%\System32\attrib.exe +h +s temp
(set/P=Analyzing firmware...<nul
(start/B %SystemRoot%\System32\certutil.exe -encodehex "%~1" temp\FW2 12&%SystemRoot%\System32\certutil.exe -encodehex "%~1" temp\FW 4)>nul||call:The_End "Firmware read error, please check and try again"
setlocal enabledelayedexpansion
for /F "tokens=1,2 delims=:" %%i in ('start/B %SystemRoot%\System32\findstr.exe /NRC:"^55 aa .. 00 f1 0e" /C:"^[0d][0e] [01]0 .. .. 00 00 1c 00" /C:"^4e 50 44 45 00 01 10 00" temp\FW')do (
	set raw=%%j
	set/A"rcheck=(%%i)%%32"
	if !rcheck!==1 (
		set/Anext_line=%%i+2
		set raw[1]=%%j
	)
	if %%i==!next_line! (
		set/Anext_line2=!next_line!+2
		set raw[2]=%%j
	)
	if %%i==!next_line2! (
		if not defined iMCA (
			set iMCA=!raw:~44,1!
			if "0x!iMCA!" lss "0x6" call:The_End "Unsupported architecture(0x!raw:~44,1!00!raw:~37,2!)"
		)
		set/An+=1
		set/AiHeader[!n!]=%%i-5
		set iBlock[!n!]=!raw[1]:~6,2!
		for /F "tokens=1-4" %%k in ("!raw[2]!")do set iDID[!n!]=%%l%%k-%%n%%m
		set iVer[!n!]=!raw:~37,2!
	)
)
if not defined n call:The_End "No GOP module detected")
set iSize=%~z1&if %iMCA%==6 (set MCA=Ampere)else if %iMCA%==7 (set MCA=Ada Lovelace)else if %iMCA%==8 (set MCA=Blackwell)else set MCA=Unknown
:Checker
set num=&set m=&for %%# in (%iMCA%*.efi)do (
	if /I "%%~x#"==".efi" (
		set "cand=%%~n#"
		if "!cand:~3,2!"=="%iBlock[1]%" (
			if "0x!cand:~1,2!" gtr "0x%iVer[1]%" (
				if not "!m!"=="9" (
					set/Am+=1
					if !m!==1 cls&echo;&echo Device ID		: %iDID[1]%&echo Architecture		: %MCA%&echo Module Quantity		: %n%&echo GOP Version		: 0x%iMCA%00%iVer[1]%&(if defined iVer[2] echo GOP Backup Version	: 0x%iMCA%00%iVer[2]%)&echo GOP Size		: 0x%iBlock[1]%&(if defined iBlock[2] echo GOP Backup Size		: 0x%iBlock[2]%)&echo;&echo [92mPlease select the version to update to.[0m&echo;
					set ELIG[!m!]=!cand!&set num=!num!!m!
					if not "!cand:~5,4!"=="" set "DID= (!cand:~5,4!)"
					for %%i in (!m!)do echo  [%%i] 0x%iMCA%00!ELIG[%%i]:~1,2!!DID!&set DID=
				)
			)
		)
	)
)
if not defined m call:The_End "The GOP module file suitable for version 0x%iMCA%00%iVer[1]% update was not found"
if not defined FID (
	for /F "tokens=2 delims=x" %%# in ('start/B %SystemRoot%\System32\fsutil.exe file queryfileid temp\FW2')do set FID=%%#
	for /F %%# in ('start/B powershell "$c=gc temp\FW2;$i=64000;while(($s=foreach($k in '020255000000000000','000000000008000006100100'){$c.IndexOf($k,$i)}) -ne -1){$s;$i+=1835000}"')do set/Ao+=1&set SIG[!o!]=%%#
)
set/Am+=1
echo;&choice/C %num%%m:~-1% /T 4 /D %m:~-1% /N&if errorlevel %m% goto Checker
cls&for /F "tokens=2 delims=x" %%# in ('start/B %SystemRoot%\System32\fsutil.exe file queryfileid temp\FW2')do if not "%FID%"=="%%#" call:The_End "Cache verification failed, please close unnecessary programs and try again"
for %%# in (!ELIG[%errorlevel%]!.efi)do if exist %%# (set/P=Processing firmware...<nul&start/B %SystemRoot%\System32\certutil.exe -encodehex %%# temp\GOP 12 >nul&set ELIG=%%~n#&if not "%%~z#"=="548" set "nodeG=,@{Start=936;Length=$([IO.File]::OpenRead('GOP').Length)-936}"&goto Full_Mode)else call:Res
for %%# in (%ELIG:~0,5%*.efi)do if not defined GOP2 if %%~z# gtr 548 %SystemRoot%\System32\certutil.exe -encodehex %%~nx# temp\GOP2 12 >nul&&set GOP2=%%~n#
if not defined GOP2 call:Res
start/B powershell "$fsi=[IO.File]::OpenRead('temp\GOP');$fsi.Seek(936,0)|Out-Null;$buffer=[byte[]]::new(160);$count=$fsi.Read($buffer,0,$buffer.Length);$fso=[IO.File]::Create('temp\GOP_p2');$fso.Write($buffer,0,$count);$fsi.Close();$fso.Close();"
set HEX=0123456789abcdef
start/B powershell "$fsi=[IO.File]::OpenRead('temp\GOP2');$s=@(@{Start=1096;Length=$fsi.Length-1100},@{Start=$fsi.Length-4;Length=4});$i=2;foreach($s in $s){$buffer=[byte[]]::new($s.Length);$fsi.Seek($s.Start,0)|Out-Null;$count=$fsi.Read($buffer,0,$s.Length);$fso=[IO.File]::Open('temp\GOP_p'+$i,[IO.FileMode]::Append,[IO.FileAccess]::Write);$fso.Write($buffer,0,$count);$fso.Close();$i++};$fsi.Close();"
:Full_Mode
pushd temp
start/B powershell "$s=@(@{Start=0;Length=104},@{Start=104;Length=832}%nodeG%);$fsi=[IO.File]::OpenRead('GOP');$i=0;foreach($s in $s){$buffer=[byte[]]::new($s.Length);$fsi.Seek($s.Start,0)|Out-Null;$count=$fsi.Read($buffer,0,$s.Length);$output='GOP_p'+$i;$fso=[IO.File]::Create($output);$fso.Write($buffer,0,$count);$fso.Close();$i++}$fsi.Close();"
set/Anode[1]=SIG[1]+104,node[2]=SIG[2]-SIG[1]-136,node[3]=SIG[2]+800,node[4]=iHeader[1]*32-SIG[2]-800,node[e]=iHeader[1]*32+0x%iBlock[1]%*1024
if "%iBlock[1]%"=="%iBlock[2]%" set/Anode[5]=node[e],node[6]=SIG[3]-node[e],node[7]=SIG[3]+104,node[8]=SIG[4]-SIG[3]-136,node[9]=SIG[4]+800,node[10]=iHeader[2]*32-SIG[4]-800,node[e]=iHeader[2]*32+0x%iBlock[2]%*1024&set node=,@{Start=!node[5]!;Length=!node[6]!},@{Start=!node[7]!;Length=!node[8]!},@{Start=!node[9]!;Length=!node[10]!}&set TypeB=+GOP_p0+p4+GOP_p1+p5+GOP_p2+p6
powershell "$s=@(@{Start=0;Length=%SIG[1]%},@{Start=%node[1]%;Length=%node[2]%},@{Start=%node[3]%;Length=%node[4]%}%node%,@{Start=%node[e]%;Length=$([IO.File]::OpenRead('FW2').Length)-%node[e]%});$fsi=[IO.File]::OpenRead('FW2');$i=0;foreach($s in $s){$buffer=[byte[]]::new($s.Length);$fsi.Seek($s.Start,0)|Out-Null;$count=$fsi.Read($buffer,0,$s.Length);$output='p'+$i;$fso=[IO.File]::Create($output);$fso.Write($buffer,0,$count);$fso.Close();$i++}$fsi.Close();"
if defined GOP2 (
	set/Pchecksum=<GOP_p3
	if not "!GOP2:~5,4!"=="" set offset=+0x%GOP2:~5,2%+0x%GOP2:~7,2%+0xee
	set/Achecksum=0xf!checksum!-0x0%ELIG:~5,4%!offset!,str=checksum/16%%16,tra=checksum%%16
	for /F "tokens=1,2" %%i in ("!str! !tra!")do echo !HEX:~%%i,1!!HEX:~%%j,1!>>GOP_p2
)
copy/B p0+GOP_p0+p1+GOP_p1+p2+GOP_p2+p3%TypeB% output>nul
popd&endlocal&set oVer=%iMCA%00%ELIG:~1,2%&set oMCA=%iMCA%00%iVer[1]%&set iSize=%iSize%&set "oName=%~nx1"
call set "oName=%%oName:%oMCA%=%oVer%%%"
if "%oName%"=="%~nx1" set "oName=%~n1_0x%oVer%%~x1"
if exist "%oName%" call:The_End "Firmware export failed, a file with the same name already exists"
%SystemRoot%\System32\certutil.exe -decodehex temp\output "%oName%">nul
for %%# in ("%oName%")do if "%%~z#"=="%iSize%" (call:The_End "[92mGOP has been updated to 0x%oVer%")else del "%%#"&call:The_End "Firmware update failed due to unknown error"
:Res
call:The_End "The required file was not found, please confirm and try again"
:The_End
rd/S/Q temp
for /F "delims=#" %%i in ('"prompt $E#&for %%# in (#)do rem"')do for /L %%# in (6,-1,1)do cls&echo;&echo [93m%~1.[0m&echo;&echo Automatically close after %%# second...&echo;&echo;&echo;&echo Version 0.1.1 (20241216)&echo Copyright (C) 2021-2024 Wudimobile%%i[?25l&timeout/T 1 >nul
exit